メインコンテンツまでスキップ
バージョン: v8

Ionic JavaScript Quickstart

Welcome! This guide will walk you through the basics of Ionic JavaScript development using Vite. You'll learn how to set up your development environment, create a simple project, explore the project structure, and understand how Ionic components work. This is perfect for getting familiar with Ionic JavaScript before building your first real app.

If you're looking for a high-level overview of what Ionic JavaScript is and how it fits into the web development ecosystem, refer to the Ionic JavaScript Overview.

Prerequisites​

Before you begin, make sure you have Node.js and npm installed on your machine. You can check by running:

node -v
npm -v

If you don't have Node.js and npm, download Node.js (which includes npm).

Create a Project with Vite​

First, create a new Vite project with vanilla JavaScript:

npm create vite@latest my-app -- --template vanilla

cd my-app

Install the project dependencies and Ionic Core:

npm install
npm install @ionic/core

After installation, start the development server:

npm run dev

Open your browser and visit the URL shown in the console.

Explore the Project Structure​

Your new app's directory will look like this:

├── index.html
└── src/
├── counter.js
├── main.js
└── style.css
Delete files

The counter.js and style.css files can be deleted. We will not be using them.

備考

All file paths in the examples below are relative to the project root directory.

Let's configure the project, initialize Ionic, and add components to create our app.

Configure Vite​

Install the vite-plugin-static-copy package:

npm install vite-plugin-static-copy --save-dev

Add a vite.config.js file at the project root with the following:

vite.config.js
import { defineConfig } from 'vite';
import { viteStaticCopy } from 'vite-plugin-static-copy';

export default defineConfig({
optimizeDeps: {
exclude: ['@ionic/core'],
},
build: {
rollupOptions: {
output: {
manualChunks: undefined,
},
external: ['/ionic.esm.js'],
},
},
plugins: [
viteStaticCopy({
targets: [
{
src: 'node_modules/@ionic/core/dist/ionic/*',
dest: '',
},
],
}),
],
});

This copies the necessary Ionic files that Capacitor will need to work with lazy loaded Ionic components.

Initialize Ionic​

Replace the contents of main.js with the following:

src/main.js
// Load Ionic
(async () => {
// Set the path to a variable to
// prevent Vite from analyzing in dev
const ionicPath = '/ionic.esm.js';
await import(/* @vite-ignore */ ionicPath);
})();

// Core CSS required for Ionic components to work properly
import '@ionic/core/css/core.css';

// Basic CSS for apps built with Ionic
import '@ionic/core/css/normalize.css';
import '@ionic/core/css/structure.css';
import '@ionic/core/css/typography.css';

// Optional CSS utils that can be commented out
import '@ionic/core/css/padding.css';
import '@ionic/core/css/float-elements.css';
import '@ionic/core/css/text-alignment.css';
import '@ionic/core/css/text-transformation.css';
import '@ionic/core/css/flex-utils.css';
import '@ionic/core/css/display.css';

This initializes Ionic based on the environment and then imports all of the available CSS files.

Add the App Component​

Update your index.html to configure the metadata and use Ionic components:

index.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
<head>
<meta charset="UTF-8" />
<link rel="icon" type="image/svg+xml" href="/vite.svg" />
<meta
name="viewport"
content="viewport-fit=cover, width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no"
/>
<title>my-app</title>
</head>
<body>
<ion-app>
<ion-router>
<ion-route url="/" component="home-page"></ion-route>
<ion-route url="/new" component="new-page"></ion-route>
</ion-router>
<ion-router-outlet></ion-router-outlet>
</ion-app>

<script type="module" src="/src/main.js"></script>
</body>
</html>

This sets up the root of your application, using Ionic's ion-app, ion-router, and ion-router-outlet components. The key change is replacing the default <div id="app"> with Ionic's routing and layout components. The router outlet is where your pages will be displayed.

View Routes​

Routes are defined in the index.html using ion-route components inside the ion-router:

index.html
<ion-router>
<ion-route url="/" component="home-page"></ion-route>
<ion-route url="/new" component="new-page"></ion-route>
</ion-router>

When you visit the root URL (/), the home-page component will be loaded. When you visit the /new URL, the new-page component will be loaded. We will define these components next.

Add the Home Page​

Create a new directory called pages inside the src folder, then add a file called HomePage.js in that directory with the following content:

src/pages/HomePage.js
class HomePage extends HTMLElement {
connectedCallback() {
this.innerHTML = `
<ion-header>
<ion-toolbar>
<ion-title>Blank</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<div id="container">
<strong>Ready to create an app?</strong>
<p>
Start with Ionic
<a target="_blank" rel="noopener noreferrer" href="https://ionicframework.com/docs/components">UI Components</a>
</p>
</div>
</ion-content>
`;
}
}

customElements.define('home-page', HomePage);

This creates a custom element called home-page that contains the layout for your Home page. The page uses Ionic's layout components to create a header with a toolbar and scrollable content area.

Learn More

For detailed information about Ionic layout components, refer to the Header, Toolbar, Title, and Content documentation.

Next, add a <script> tag before the main.js import in index.html to import the Home page:

index.html
<script type="module">
import './src/pages/HomePage.js';
</script>

<script type="module" src="/src/main.js"></script>

At this point your browser should be displaying the Home page.

Screenshot of the Ionic Core Home page

Add an Ionic Component​

You can enhance your Home page with more Ionic UI components. For example, add a Button to navigate to another page. Update the HomePage component in HomePage.js:

src/pages/HomePage.js
class HomePage extends HTMLElement {
connectedCallback() {
this.innerHTML = `
<ion-header>
<ion-toolbar>
<ion-title>Blank</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<div id="container">
<strong>Ready to create an app?</strong>
<p>
Start with Ionic
<a target="_blank" rel="noopener noreferrer" href="https://ionicframework.com/docs/components">UI Components</a>
</p>
</div>

<ion-button>Navigate</ion-button>
</ion-content>
`;
}
}

customElements.define('home-page', HomePage);

Add a New Page​

Add a new file named NewPage.js to src/pages with the following content:

src/pages/NewPage.js
class NewPage extends HTMLElement {
connectedCallback() {
this.innerHTML = `
<ion-header>
<ion-toolbar>
<ion-buttons slot="start">
<ion-back-button default-href="/"></ion-back-button>
</ion-buttons>
<ion-title>New</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<h2>Welcome to the new page!</h2>
</ion-content>
`;
}
}

customElements.define('new-page', NewPage);

This creates a page with a Back Button in the Toolbar. The back button will automatically handle navigation back to the previous page, or to / if there is no history.

Next, update the <script> tag which imports the Home page in the index.html file to also import the New page:

index.html
<script type="module">
import './src/pages/HomePage.js';
import './src/pages/NewPage.js';
</script>

To navigate to the new page, update the button in HomePage.js to be inside of an ion-router-link:

src/pages/HomePage.js
<ion-router-link href="/new">
<ion-button>Navigate</ion-button>
</ion-router-link>

When the button is clicked, Ionic's router will automatically navigate to the /new route and display the new-page component.

備考

Navigating can also be performed programmatically using document.querySelector('ion-router').push('/new'). Refer to the Ionic Router documentation for more information.

Add Icons to the New Page​

Ionic JavaScript comes with Ionicons support. To use icons, you need to import them, register them with addIcons, and then use them with the ion-icon component.

Add the necessary imports and register the icons in main.js:

src/main.js
// ...Ionic initialization

// Icon imports
import { addIcons } from 'ionicons';
import { heart, logoIonic } from 'ionicons/icons';

addIcons({ heart, logoIonic });

// ...CSS imports

Next, update NewPage.js to include the icons:

src/pages/NewPage.js
class NewPage extends HTMLElement {
connectedCallback() {
this.innerHTML = `
<ion-header>
<ion-toolbar>
<ion-buttons slot="start">
<ion-back-button default-href="/"></ion-back-button>
</ion-buttons>
<ion-title>New</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<h2>Welcome to the new page!</h2>

<ion-icon name="heart"></ion-icon>
<ion-icon name="logo-ionic"></ion-icon>
</ion-content>
`;
}
}

customElements.define('new-page', NewPage);

For more information, refer to the Icon documentation and the Ionicons documentation.

Call Component Methods​

Let's add a button that can scroll the content area to the bottom. Update NewPage.js to include scrollable content and a scroll button:

src/pages/NewPage.js
class NewPage extends HTMLElement {
connectedCallback() {
this.innerHTML = `
<ion-header>
<ion-toolbar>
<ion-buttons slot="start">
<ion-back-button default-href="/"></ion-back-button>
</ion-buttons>
<ion-title>New</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<h2>Welcome to the new page!</h2>

<ion-icon name="heart"></ion-icon>
<ion-icon name="logo-ionic"></ion-icon>

<ion-button id="scroll-btn">Scroll to Bottom</ion-button>

<!-- Add lots of content to make scrolling possible -->
<div id="item-list"></div>
</ion-content>
`;

// Generate items and add scroll functionality after the element is connected
this.setupScrolling();
}

setupScrolling() {
// Wait for ion-content to be ready
customElements.whenDefined('ion-content').then(() => {
// Generate items
const itemList = this.querySelector('#item-list');
for (let i = 1; i <= 50; i++) {
const item = document.createElement('ion-item');
const label = document.createElement('ion-label');
label.textContent = `Item ${i}`;
item.appendChild(label);
itemList.appendChild(item);
}

// Add scroll functionality
const scrollBtn = this.querySelector('#scroll-btn');
const content = this.querySelector('ion-content');

if (scrollBtn && content) {
scrollBtn.addEventListener('click', () => {
content.scrollToBottom(300);
});
}
});
}
}

customElements.define('new-page', NewPage);

To call methods on Ionic components:

  1. Get a reference to the component element using querySelector
  2. Call the method directly on the element

You can find available methods for each component in the Methods section of their API documentation.

Run on a Device​

Ionic's components work everywhere: on iOS, Android, and PWAs. To deploy to mobile, use Capacitor:

npm install @capacitor/core @capacitor/cli @capacitor/ios @capacitor/android
npx cap init

npm run build

npx cap add ios
npx cap add android

Open the native projects in their IDEs:

npx cap open ios
npx cap open android

Refer to Capacitor's Getting Started guide for more.

Framework Integrations​

Ionic Core also works with other frameworks and libraries that support custom elements, such as Alpine.js, Lit, and Svelte. However, when using Ionic Core with these libraries, you won't have the built-in form and routing capabilities that are tightly coupled with Ionic's official Angular, React, and Vue framework integrations, and will need to use their respective routing and form solutions instead.

Explore More​

This guide covered the basics of creating an Ionic JavaScript app with Vite, adding navigation, and introducing Capacitor for native builds. To dive deeper, check out:

Vite Documentation

Learn advanced Vite configuration and optimization techniques for Ionic JavaScript apps.

JavaScript Documentation

Learn more about JavaScript's core concepts, tools, and best practices from MDN Web Docs.

Navigation

Discover how to handle routing and navigation in Ionic JavaScript apps using the Ionic Router.

Components

Explore Ionic's rich library of UI components for building beautiful apps.

Theming

Learn how to customize the look and feel of your app with Ionic's powerful theming system.

Capacitor Documentation

Explore how to access native device features and deploy your app to iOS, Android, and the web with Capacitor.

メインコンテンツまでスキップ
バージョン: v7

Ionic React Quickstart

Welcome! This guide will walk you through the basics of Ionic React development. You'll learn how to set up your development environment, generate a simple project, explore the project structure, and understand how Ionic components work. This is perfect for getting familiar with Ionic React before building your first real app.

If you're looking for a high-level overview of what Ionic React is and how it fits into the React ecosystem, see the Ionic React Overview.

Prerequisites

Before you begin, make sure you have Node.js and npm installed on your machine. You can check by running:

node -v
npm -v

If you don't have Node.js and npm, download Node.js here (which includes npm).

Create a Project with the Ionic CLI

First, install the latest Ionic CLI:

npm install -g @ionic/cli

Then, run the following commands to create and run a new project:

ionic start myApp blank --type react

cd myApp
ionic serve

After running ionic serve, your project will open in the browser.

Screenshot of the Ionic React Home page

Explore the Project Structure

Your new app's directory will look like this:

└── src/
├── App.tsx
├── components
│ ├── ExploreContainer.css
│ └── ExploreContainer.tsx
├── main.tsx
└── pages
├── Home.css
└── Home.tsx
備考

All file paths in the examples below are relative to the project root directory.

Let's walk through these files to understand the app's structure.

View the App Component

The root of your app is defined in App.tsx:

src/App.tsx
import { Redirect, Route } from 'react-router-dom';
import { IonApp, IonRouterOutlet, setupIonicReact } from '@ionic/react';
import { IonReactRouter } from '@ionic/react-router';
import Home from './pages/Home';

// ..CSS imports...

setupIonicReact();

const App: React.FC = () => (
<IonApp>
<IonReactRouter>
<IonRouterOutlet>
<Route exact path="/home">
<Home />
</Route>
<Route exact path="/">
<Redirect to="/home" />
</Route>
</IonRouterOutlet>
</IonReactRouter>
</IonApp>
);

export default App;

This sets up the root of your application, using Ionic's IonApp and IonReactRouter components. The IonRouterOutlet is where your pages will be displayed.

View Routes

Routes are defined within the IonRouterOutlet in App.tsx:

src/App.tsx
<IonRouterOutlet>
<Route exact path="/home">
<Home />
</Route>
<Route exact path="/">
<Redirect to="/home" />
</Route>
</IonRouterOutlet>

When you visit the root URL (/), the Home component will be loaded.

View the Home Page

The Home page component, defined in Home.tsx, imports the Ionic components and defines the page template:

src/pages/Home.tsx
import { IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/react';
import ExploreContainer from '../components/ExploreContainer';
import './Home.css';

const Home: React.FC = () => {
return (
<IonPage>
<IonHeader>
<IonToolbar>
<IonTitle>Blank</IonTitle>
</IonToolbar>
</IonHeader>
<IonContent fullscreen>
<IonHeader collapse="condense">
<IonToolbar>
<IonTitle size="large">Blank</IonTitle>
</IonToolbar>
</IonHeader>
<ExploreContainer />
</IonContent>
</IonPage>
);
};

export default Home;

This creates a page with a header and scrollable content area. The IonPage component provides the basic page structure and must be used on every page. The second header shows a collapsible large title that displays on iOS devices when at the top of the content, then condenses to show the smaller title in the first header when scrolling down.

Learn More

For detailed information about Ionic layout components, see the Header, Toolbar, Title, and Content documentation.

Add an Ionic Component

You can enhance your Home page with more Ionic UI components. For example, import and add a Button at the end of the IonContent in Home.tsx:

src/pages/Home.tsx
import { IonButton, IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/react';
// ...existing imports...

const Home: React.FC = () => {
return (
<IonPage>
<IonHeader>
<IonToolbar>
<IonTitle>Blank</IonTitle>
</IonToolbar>
</IonHeader>
<IonContent fullscreen>
{/* ...existing content... */}

<IonButton>Navigate</IonButton>
</IonContent>
</IonPage>
);
};

export default Home;

Add a New Page

Create a new page at New.tsx:

src/pages/New.tsx
import { IonBackButton, IonButtons, IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/react';

const New: React.FC = () => {
return (
<IonPage>
<IonHeader>
<IonToolbar>
<IonButtons slot="start">
<IonBackButton defaultHref="/"></IonBackButton>
</IonButtons>
<IonTitle>New</IonTitle>
</IonToolbar>
</IonHeader>
<IonContent fullscreen>
<IonHeader collapse="condense">
<IonToolbar>
<IonTitle size="large">New</IonTitle>
</IonToolbar>
</IonHeader>
</IonContent>
</IonPage>
);
};

export default New;

This creates a page with a Back Button in the Toolbar. The back button will automatically handle navigation back to the previous page, or to / if there is no history.

警告

When creating your own pages, always use IonPage as the root component. This is essential for proper transitions between pages, base CSS styling that Ionic components depend on, and consistent layout behavior across your app.

To navigate to the new page, create a route for it by first importing it at the top of App.tsx after the Home import:

src/App.tsx
import New from './pages/New';

Then, add its route in IonRouterOutlet:

src/App.tsx
<IonRouterOutlet>
<Route exact path="/home">
<Home />
</Route>
<Route exact path="/new">
<New />
</Route>
<Route exact path="/">
<Redirect to="/home" />
</Route>
</IonRouterOutlet>

Once that is done, update the button in Home.tsx:

src/pages/Home.tsx
<IonButton routerLink="/new">Navigate</IonButton>
備考

Navigating can also be performed programmatically using React Router's history prop. See the React Navigation documentation for more information.

Add Icons to the New Page

Ionic React comes with Ionicons pre-installed. You can use any icon by setting the icon property of the IonIcon component.

Update the imports in New.tsx to import IonIcon and the heart and logoIonic icons:

src/pages/New.tsx
import { IonBackButton, IonButtons, IonContent, IonHeader, IonIcon, IonPage, IonTitle, IonToolbar } from '@ionic/react';
import { heart, logoIonic } from 'ionicons/icons';

Then, include them inside of the IonContent:

src/pages/New.tsx
<IonIcon icon={heart} />
<IonIcon icon={logoIonic} />

Note that we are passing the imported SVG reference, not the icon name as a string.

For more information, see the Icon documentation and the Ionicons documentation.

Call Component Methods

Let's add a button that can scroll the content area to the bottom.

Update New.tsx to add a ref on IonContent and a button and some items after the existing icons:

src/pages/New.tsx
<IonContent ref={content}>
<IonIcon icon={heart} />
<IonIcon icon={logoIonic} />

<IonButton onClick={scrollToBottom}>Scroll to Bottom</IonButton>

{/* Add lots of content to make scrolling possible */}
{Array.from({ length: 50 }, (_, i) => (
<IonItem key={i}>
<IonLabel>Item {i + 1}</IonLabel>
</IonItem>
))}
</IonContent>

Then, add the imports for the additional components and define the scrollToBottom function:

src/pages/New.tsx
import { useRef } from 'react';
import { IonButton, IonBackButton, IonButtons, IonContent, IonHeader, IonIcon, IonItem, IonLabel, IonPage, IonTitle, IonToolbar } from '@ionic/react';
import { heart, logoIonic } from 'ionicons/icons';

const New: React.FC = () => {
const content = useRef<HTMLIonContentElement>(null);

const scrollToBottom = () => {
content.current?.scrollToBottom(300);
};

return (
// ...existing template...
);
};

export default New;

To call methods on Ionic components:

  1. Create a ref for the component
  2. Call the method directly on ref.current

This pattern is necessary because React refs store the component instance in the .current property.

You can find available methods for each component in the Methods section of their API documentation.

Run on a Device

Ionic's components work everywhere: on iOS, Android, and PWAs. To deploy to mobile, use Capacitor:

ionic build
ionic cap add ios
ionic cap add android

Open the native projects in their IDEs:

ionic cap open ios
ionic cap open android

See Capacitor's Getting Started guide for more.

Explore More

This guide covered the basics of creating an Ionic React app, adding navigation, and introducing Capacitor for native builds. To dive deeper, check out:

Build Your First App

Build a real Photo Gallery app with Ionic React and native device features.

React Documentation

Learn more about React's core concepts, tools, and best practices from the official React documentation.

Navigation

Discover how to handle routing and navigation in Ionic React apps using the React Router.

Components

Explore Ionic's rich library of UI components for building beautiful apps.

Theming

Learn how to customize the look and feel of your app with Ionic's powerful theming system.

Capacitor Documentation

Explore how to access native device features and deploy your app to iOS, Android, and the web with Capacitor.

メインコンテンツまでスキップ
バージョン: v8

Ionic Vue Quickstart

Welcome! This guide will walk you through the basics of Ionic Vue development. You'll learn how to set up your development environment, generate a simple project, explore the project structure, and understand how Ionic components work. This is perfect for getting familiar with Ionic Vue before building your first real app.

If you're looking for a high-level overview of what Ionic Vue is and how it fits into the Vue ecosystem, refer to the Ionic Vue Overview.

Prerequisites​

Before you begin, make sure you have Node.js and npm installed on your machine. You can check by running:

node -v
npm -v

If you don't have Node.js and npm, download Node.js (which includes npm).

Create a Project with the Ionic CLI​

First, install the latest Ionic CLI:

npm install -g @ionic/cli

Then, run the following commands to create and run a new project:

ionic start myApp blank --type vue

cd myApp
ionic serve

After running ionic serve, your project will open in the browser.

Screenshot of the Ionic Vue Home page

Explore the Project Structure​

Your new app's directory will look like this:

└── src/
├── App.vue
├── main.ts
├── router
│   └── index.ts
└── views
   └── HomePage.vue
備考

All file paths in the examples below are relative to the project root directory.

Let's walk through these files to understand the app's structure.

View the App Component​

The root of your app is defined in App.vue:

src/App.vue
<template>
<ion-app>
<ion-router-outlet />
</ion-app>
</template>

<script setup lang="ts">
import { IonApp, IonRouterOutlet } from '@ionic/vue';
</script>

This sets up the root of your application, using Ionic's ion-app and ion-router-outlet components. The router outlet is where your pages will be displayed.

View Routes​

Routes are defined in router/index.ts:

src/router/index.ts
import { createRouter, createWebHistory } from '@ionic/vue-router';
import { RouteRecordRaw } from 'vue-router';
import HomePage from '../views/HomePage.vue';

const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home',
},
{
path: '/home',
name: 'Home',
component: HomePage,
},
];

const router = createRouter({
history: createWebHistory(import.meta.env.BASE_URL),
routes,
});

export default router;

When you visit the root URL (/), the HomePage component will be loaded.

View the Home Page​

The Home page component, defined in HomePage.vue, imports the Ionic components and defines the page template:

src/views/HomePage.vue
<template>
<ion-page>
<ion-header :translucent="true">
<ion-toolbar>
<ion-title>Blank</ion-title>
</ion-toolbar>
</ion-header>

<ion-content :fullscreen="true">
<ion-header collapse="condense">
<ion-toolbar>
<ion-title size="large">Blank</ion-title>
</ion-toolbar>
</ion-header>

<div id="container">
<strong>Ready to create an app?</strong>
<p>
Start with Ionic
<a target="_blank" rel="noopener noreferrer" href="https://ionicframework.com/docs/components"
>UI Components</a
>
</p>
</div>
</ion-content>
</ion-page>
</template>

<script setup lang="ts">
import { IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/vue';
</script>

<!-- ...styles... -->

This creates a page with a header and scrollable content area. The second header shows a collapsible large title that displays on iOS devices when at the top of the content, then condenses to show the smaller title in the first header when scrolling down.

Learn More

For detailed information about Ionic layout components, refer to the Header, Toolbar, Title, and Content documentation.

Add an Ionic Component​

You can enhance your Home page with more Ionic UI components. For example, add a Button at the end of the ion-content:

src/views/HomePage.vue
<ion-content>
<!-- existing content -->

<ion-button>Navigate</ion-button>
</ion-content>

Then, import the IonButton component in the <script> tag:

src/views/HomePage.vue
<script setup lang="ts">
import { IonButton, IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/vue';
</script>

Add a New Page​

Create a new page at NewPage.vue:

src/views/NewPage.vue
<template>
<ion-page>
<ion-header :translucent="true">
<ion-toolbar>
<ion-buttons slot="start">
<ion-back-button default-href="/"></ion-back-button>
</ion-buttons>
<ion-title>New</ion-title>
</ion-toolbar>
</ion-header>

<ion-content :fullscreen="true">
<ion-header collapse="condense">
<ion-toolbar>
<ion-title size="large">New</ion-title>
</ion-toolbar>
</ion-header>
</ion-content>
</ion-page>
</template>

<script setup lang="ts">
import { IonBackButton, IonButtons, IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/vue';
</script>

This creates a page with a Back Button in the Toolbar. The back button will automatically handle navigation back to the previous page, or to / if there is no history.

警告

When creating your own pages, always use ion-page as the root component. This is essential for proper transitions between pages, base CSS styling that Ionic components depend on, and consistent layout behavior across your app.

To navigate to the new page, create a route for it by first importing it at the top of router/index.ts after the HomePage import:

src/router/index.ts
import NewPage from '../views/NewPage.vue';

Then, add its route in the routes array:

src/router/index.ts
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home',
},
{
path: '/home',
name: 'Home',
component: HomePage,
},
{
path: '/new',
name: 'New',
component: NewPage,
},
];

Once that is done, update the button in HomePage.vue:

src/views/HomePage.vue
<ion-button router-link="/new">Navigate</ion-button>
備考

Navigating can also be performed programmatically using Vue Router, and routes can be lazy loaded for better performance. Refer to the Vue Navigation documentation for more information.

Add Icons to the New Page​

Ionic Vue comes with Ionicons pre-installed. You can use any icon by setting the icon property of the ion-icon component.

Update the imports in NewPage.vue to import IonIcon and the heart and logoIonic icons:

src/views/NewPage.vue
<script setup lang="ts">
import { IonBackButton, IonButtons, IonContent, IonHeader, IonIcon, IonPage, IonTitle, IonToolbar } from '@ionic/vue';
import { heart, logoIonic } from 'ionicons/icons';
</script>

Then, include them inside of the ion-content:

src/views/NewPage.vue
<ion-icon :icon="heart"></ion-icon>
<ion-icon :icon="logoIonic"></ion-icon>

Note that we are passing the imported SVG reference, not the icon name as a string.

For more information, refer to the Icon documentation and the Ionicons documentation.

Call Component Methods​

Let's add a button that can scroll the content area to the bottom.

Update NewPage.vue to include a ref on ion-content and a button and some items after the existing icons:

src/views/NewPage.vue
<ion-content ref="content">
<ion-button @click="scrollToBottom">Scroll to Bottom</ion-button>

<!-- Add lots of content to make scrolling possible -->
<ion-item v-for="i in 50" :key="i">
<ion-label>Item {{ i }}</ion-label>
</ion-item>
</ion-content>

In the script section, add the new component imports and define the scrollToBottom function:

src/views/NewPage.vue
<script setup lang="ts">
import {
IonBackButton,
IonButtons,
IonButton,
IonContent,
IonHeader,
IonIcon,
IonItem,
IonLabel,
IonPage,
IonTitle,
IonToolbar,
} from '@ionic/vue';
import { heart, logoIonic } from 'ionicons/icons';
import { ref } from 'vue';

const content = ref();

const scrollToBottom = () => {
content.value.$el.scrollToBottom(300);
};
</script>

To call methods on Ionic components:

  1. Create a ref for the component
  2. Access the underlying Web Component via $el
  3. Call the method on the Web Component

This pattern is necessary because Ionic components are built as Web Components. The $el property gives you access to the actual Web Component instance where the methods are defined.

You can find available methods for each component in the Methods section of their API documentation.

Run on a Device​

Ionic's components work everywhere: on iOS, Android, and PWAs. To deploy to mobile, use Capacitor:

ionic build
ionic cap add ios
ionic cap add android

Open the native projects in their IDEs:

ionic cap open ios
ionic cap open android

Refer to Capacitor's Getting Started guide for more.

Build with TypeScript or JavaScript​

Ionic Vue projects are created with TypeScript by default, but you can easily convert to JavaScript if you prefer. After generating a blank Ionic Vue app, follow these steps:

  1. Remove the TypeScript dependencies:
npm uninstall --save typescript @types/jest @typescript-eslint/eslint-plugin @typescript-eslint/parser @vue/cli-plugin-typescript @vue/eslint-config-typescript vue-tsc
  1. Change the extension of all .ts files to .js. In a blank Ionic Vue app, this will be the src/router/index.ts, src/main.ts, and files in the tests directory.

  2. In index.html, change the imported <script> file from /src/main.ts to /src/main.js.

  3. Remove @vue/typescript/recommended and @typescript-eslint/no-explicit-any: 'off' from .eslintrc.js.

  4. Remove Array<RouteRecordRaw> and the import of RouteRecordRaw from src/router/index.js.

  5. Remove lang="ts" from the script tags in any of your Vue components that have them. In a blank Ionic Vue app, this should only be src/App.vue and src/views/HomePage.vue.

  6. Delete tsconfig.json and vite-env.d.ts.

  7. In package.json, change the build script from "build": "vue-tsc && vite build" to "build": "vite build".

  8. Install terser npm i -D terser.

Explore More​

This guide covered the basics of creating an Ionic Vue app, adding navigation, and introducing Capacitor for native builds. To dive deeper, check out:

Build Your First App

Build a real Photo Gallery app with Ionic Vue and native device features.

Vue Documentation

Learn more about Vue's core concepts, tools, and best practices from the official Vue documentation.

Navigation

Discover how to handle routing and navigation in Ionic Vue apps using the Vue Router.

Components

Explore Ionic's rich library of UI components for building beautiful apps.

Theming

Learn how to customize the look and feel of your app with Ionic's powerful theming system.

Capacitor Documentation

Explore how to access native device features and deploy your app to iOS, Android, and the web with Capacitor.

メインコンテンツまでスキップ
バージョン: v8

Ionic Angular Quickstart

Welcome! This guide will walk you through the basics of Ionic Angular development. You'll learn how to set up your development environment, generate a simple project, explore the project structure, and understand how Ionic components work. This is perfect for getting familiar with Ionic Angular before building your first real app.

If you're looking for a high-level overview of what Ionic Angular is and how it fits into the Angular ecosystem, refer to the Ionic Angular Overview.

Prerequisites​

Before you begin, make sure you have Node.js and npm installed on your machine. You can check by running:

node -v
npm -v

If you don't have Node.js and npm, download Node.js (which includes npm).

Create a Project with the Ionic CLI​

First, install the latest Ionic CLI:

npm install -g @ionic/cli

Then, run the following commands to create and run a new project:

ionic start myApp blank --type angular

cd myApp
ionic serve

At the first prompt, choose Standalone.

After running ionic serve, your project will open in the browser.

Screenshot of the Ionic Angular Home page

Explore the Project Structure​

Your new app's directory will look like this:

└── src/
└── app
├── app.component.html
├── app.component.scss
├── app.component.ts
├── app.routes.ts
└── home/
├── home.page.html
├── home.page.scss
├── home.page.spec.ts
└── home.page.ts
備考

All file paths in the examples below are relative to the project root directory.

Let's walk through these files to understand the app's structure.

View the App Component​

The root of your app is defined in app.component.ts:

src/app/app.component.ts
import { Component } from '@angular/core';
import { IonApp, IonRouterOutlet } from '@ionic/angular/standalone';

@Component({
selector: 'app-root',
templateUrl: 'app.component.html',
imports: [IonApp, IonRouterOutlet],
})
export class AppComponent {
constructor() {}
}

And its template in app.component.html:

src/app/app.component.html
<ion-app>
<ion-router-outlet></ion-router-outlet>
</ion-app>

This sets up the root of your application, using Ionic's ion-app and ion-router-outlet components. The router outlet is where your pages will be displayed.

View Routes​

Routes are defined in app.routes.ts:

src/app/app.routes.ts
import { Routes } from '@angular/router';

export const routes: Routes = [
{
path: 'home',
loadComponent: () => import('./home/home.page').then((m) => m.HomePage),
},
{
path: '',
redirectTo: 'home',
pathMatch: 'full',
},
];

When you visit the root URL (/), the HomePage component will be loaded.

View the Home Page​

The Home page component, defined in home.page.ts, imports the Ionic components it uses:

src/app/home/home.page.ts
import { Component } from '@angular/core';
import { IonHeader, IonToolbar, IonTitle, IonContent } from '@ionic/angular/standalone';

@Component({
selector: 'app-home',
templateUrl: 'home.page.html',
styleUrls: ['home.page.scss'],
imports: [IonHeader, IonToolbar, IonTitle, IonContent],
})
export class HomePage {
constructor() {}
}

And the template, in the home.page.html file, uses those components:

src/app/home/home.page.html
<ion-header [translucent]="true">
<ion-toolbar>
<ion-title> Blank </ion-title>
</ion-toolbar>
</ion-header>

<ion-content [fullscreen]="true">
<ion-header collapse="condense">
<ion-toolbar>
<ion-title size="large">Blank</ion-title>
</ion-toolbar>
</ion-header>

<div id="container">
<strong>Ready to create an app?</strong>
<p>
Start with Ionic
<a target="_blank" rel="noopener noreferrer" href="https://ionicframework.com/docs/components">UI Components</a>
</p>
</div>
</ion-content>

This creates a page with a header and scrollable content area. The second header shows a collapsible large title that displays on iOS devices when at the top of the content, then condenses to show the smaller title in the first header when scrolling down.

Learn More

For detailed information about Ionic layout components, refer to the Header, Toolbar, Title, and Content documentation.

Add an Ionic Component​

You can enhance your Home page with more Ionic UI components. For example, add a Button at the end of the ion-content:

src/app/home/home.page.html
<ion-content>
<!-- existing content -->

<ion-button>Navigate</ion-button>
</ion-content>

Then, import the IonButton component in home.page.ts:

src/app/home/home.page.ts
import { IonButton, IonContent, IonHeader, IonTitle, IonToolbar } from '@ionic/angular/standalone';

@Component({
// ...existing config...
imports: [IonButton, IonContent, IonHeader, IonTitle, IonToolbar],
})

Add a New Page​

To add a new page, generate it with the CLI:

ionic generate page new

A route will be automatically added to app.routes.ts.

In new.page.html, you can add a Back Button to the Toolbar:

src/app/new/new.page.html
<ion-header [translucent]="true">
<ion-toolbar>
<ion-buttons slot="start">
<ion-back-button defaultHref="/"></ion-back-button>
</ion-buttons>
<ion-title>new</ion-title>
</ion-toolbar>
</ion-header>

And import IonBackButton and IonButtons in new.page.ts:

src/app/new/new.page.ts
import { IonBackButton, IonButtons, IonContent, IonHeader, IonTitle, IonToolbar } from '@ionic/angular/standalone';

@Component({
// ...existing config...
imports: [IonBackButton, IonButtons, IonContent, IonHeader, IonTitle, IonToolbar],
})

The ion-back-button will automatically handle navigation back to the previous page, or to / if there is no history.

To navigate to the new page, update the button in home.page.html:

src/app/home/home.page.html
<ion-button [routerLink]="['/new']">Navigate</ion-button>

Then, import RouterLink in home.page.ts:

src/app/home/home.page.ts
import { RouterLink } from '@angular/router';

@Component({
// ...existing config...
imports: [IonButton, IonContent, IonHeader, IonTitle, IonToolbar, RouterLink],
})
備考

Navigating can also be performed using Angular's Router service. Refer to the Angular Navigation documentation for more information.

Add Icons to the New Page​

Ionic Angular comes with Ionicons pre-installed. You can use any icon by setting the name property on the ion-icon component. Add the following icons to new.page.html:

src/app/new/new.page.html
<ion-content>
<!-- existing content -->

<ion-icon name="heart"></ion-icon>
<ion-icon name="logo-ionic"></ion-icon>
</ion-content>

You'll also need to import and register these icons in new.page.ts:

src/app/new/new.page.ts
// ...existing imports...
import { IonBackButton, IonButtons, IonContent, IonHeader, IonIcon, IonTitle, IonToolbar } from '@ionic/angular/standalone';
import { addIcons } from 'ionicons';
import { heart, logoIonic } from 'ionicons/icons';

@Component({
// ...existing config...
imports: [IonBackButton, IonButtons, IonContent, IonHeader, IonIcon, IonTitle, IonToolbar],
})

Then, update the constructor of the page to use addIcons:

src/app/new/new.page.ts
export class NewPage implements OnInit {
constructor() {
addIcons({ heart, logoIonic });
}

ngOnInit() {}
}

Alternatively, you can register icons in app.component.ts to use them throughout your app.

For more information, refer to the Icon documentation and the Ionicons documentation.

Call Component Methods​

Let's add a button that can scroll the content area to the bottom.

Update the ion-content in your new.page.html to include a button and some items after the existing icons:

src/app/new/new.page.html
<ion-content [fullscreen]="true" #content>
<ion-header collapse="condense">
<ion-toolbar>
<ion-title size="large">new</ion-title>
</ion-toolbar>
</ion-header>

<ion-icon name="heart"></ion-icon>
<ion-icon name="logo-ionic"></ion-icon>

<ion-button (click)="scrollToBottom()">Scroll to Bottom</ion-button>

<!-- Add lots of content to make scrolling possible -->
@for (item of items; track $index; let i = $index) {
<ion-item>
<ion-label>Item {{ i + 1 }}</ion-label>
</ion-item>
}
</ion-content>

In the component, add the ViewChild import, the new component imports and define the scrollToBottom function:

src/app/new/new.page.ts
import { Component, OnInit, ViewChild } from '@angular/core';
import {
IonBackButton,
IonButton,
IonButtons,
IonContent,
IonHeader,
IonIcon,
IonItem,
IonLabel,
IonTitle,
IonToolbar,
} from '@ionic/angular/standalone';
import { addIcons } from 'ionicons';
import { heart, logoIonic } from 'ionicons/icons';

@Component({
// ...existing config...
imports: [
IonBackButton,
IonButton,
IonButtons,
IonContent,
IonHeader,
IonIcon,
IonItem,
IonLabel,
IonTitle,
IonToolbar,
],
})
export class NewPage implements OnInit {
@ViewChild(IonContent) content!: IonContent;

items = Array.from({ length: 50 }, (_, i) => i);

constructor() {
addIcons({ heart, logoIonic });
}

ngOnInit() {}

scrollToBottom = () => {
this.content.scrollToBottom(300);
};
}

To call methods on Ionic components:

  1. Create a ViewChild reference for the component
  2. Call the method directly on the component instance

You can find available methods for each component in the Methods section of their API documentation.

Run on a Device​

Ionic's components work everywhere: on iOS, Android, and PWAs. To deploy to mobile, use Capacitor:

ionic build
ionic cap add ios
ionic cap add android

Open the native projects in their IDEs:

ionic cap open ios
ionic cap open android

Refer to Capacitor's Getting Started guide for more.

Explore More​

This guide covered the basics of creating an Ionic Angular app, adding navigation, and introducing Capacitor for native builds. To dive deeper, check out:

Build Your First App

Build a real Photo Gallery app with Ionic Angular and native device features.

Angular Documentation

Learn more about Angular's core concepts, tools, and best practices from the official Angular documentation.

Navigation

Discover how to handle routing and navigation in Ionic Angular apps using the Angular Router.

Components

Explore Ionic's rich library of UI components for building beautiful apps.

Theming

Learn how to customize the look and feel of your app with Ionic's powerful theming system.

Capacitor Documentation

Explore how to access native device features and deploy your app to iOS, Android, and the web with Capacitor.